#include "StdAfx.h"
#include "Entity.h"

CEntity::CEntity(void)
{
	D3DXMatrixIdentity(&m_matrix);
	m_pParent = NULL;
}

CEntity::~CEntity(void)
{
}

const D3DXMATRIX CEntity::GetMatrix() const
{
	if (!m_pParent)
	{
		return m_matrix;
	}
	D3DXMATRIXA16 m = m_pParent->GetMatrix();
	D3DXMatrixMultiply(&m, &m_matrix, &m);
	return m;
}

D3DXVECTOR3 CEntity::GetPos() const
{
	return D3DXVECTOR3(m_matrix._41, m_matrix._42, m_matrix._42);
}

void CEntity::SetMatrix( const D3DXMATRIX& mat )
{
	m_matrix = mat;
}

void CEntity::SetRotation( const D3DXMATRIX& mat )
{
	memcpy(&m_matrix._11, &mat._11, 3*4*sizeof(float));
}

void CEntity::SetPos( const D3DXVECTOR3& pos )
{
	memcpy(&m_matrix.m[3], &pos, 3*sizeof(float));
}

void CEntity::SetParent( CEntity* pParent )
{
	m_pParent = pParent;
}
